<?php
namespace DsbNext\Services;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class ParametersIndicatorsService {
  public function __construct($entityManager, $environment){
    $this->connection = $entityManager->getConnection();
    $this->environment = $environment;
  }
  
  public function beginTransaction() {
    $this->connection->beginTransaction();
  }
  
  public function commit() {
    $this->connection->commit();
  }
  
  public function rollback() {
    $this->connection->rollback();
  }
  
  public function updateShowOnDashboardStatus($params) {
    $sqlUpdate =  "UPDATE SERVICO
                      SET IDINDICADOR   = :P_IDINDICADOR
                    WHERE CDSERVFILI    = :P_CDSERVFILI
                          AND CDFILIAL  = :P_CDFILIAL ";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function updateAfTrackingTotal($params) {
    $sqlUpdate = "UPDATE INDICADORTF
                     SET VRLIMMETA     = :P_VRLIMMETA,
                         VRLIMMINIMO   = :P_VRLIMMINIMO
                   WHERE NRINDICADORTF = 29
                     AND NRORG         = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function saveUnitManager($params) {
    $sqlUpdate = " UPDATE PARAMGESTAO 
                      SET CDGRUPPROD      = :P_CDGRUPOPROD,
                          IDCONSXMLCOMFIL = :P_IDCONSXMLCOMFIL
                    WHERE CDPARAMGESTAO   = '0001'
                      AND NRORG           = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  public function updateAfTrackingAnnual($params) {
    $sqlUpdate = "UPDATE INDICADORTF
                    SET VRLIMMETA     = :P_VRLIMMETA
                  WHERE NRINDICADORTF = 32
                    AND NRORG         = :P_NRORG";
    try{
      $std = $this->connection->prepare($sqlUpdate);
      $std->execute($params);
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function aFTracking(){
    $sql = "SELECT NRINDICADORTF, VRLIMMETA, VRLIMMINIMO 
                  FROM INDICADORTF 
                  WHERE NRINDICADORTF IN (29,32)";
    try{
      $std = $this->connection->prepare();
      $std->execute();
    }catch(Exception $e) {
      throw $e; 
    }
  }
}