import { IConfig } from '@zeedhi/core';
import prodEnvironment from './prodEnvironment.json';
import devEnvironment from './devEnvironment.json';

const env = process.env.NODE_ENV === 'production' ? prodEnvironment : devEnvironment;

const config: IConfig = {
  endPoint: env.endPoint,
  metadataEndPoint: env.metadataEndPoint,
  env: {
    endPoint: env.endPoint,
  },
  masks: {
    numberMask: {
      decimalCharacter: ',',
      digitGroupSeparator: '.',
    },
  },
};

export default config;
