import {
  Metadata,
  Http,
  IEventParam,
} from '@zeedhi/core';
import {
  Select,
  GridEditable,
  Button,
  Number,
  CollapseCard,
  // Form,
  Switch,
} from '@zeedhi/common';
import {} from '@zeedhi/teknisa-components-common';

export class ParametersIndicatorsController {
  private criticalValue = '';
  
  public isNotInlineToggleEditing = true;
  
  public onInlineEditToggle({ component }: IEventParam<GridEditable>) {
    this.isNotInlineToggleEditing = !component.editing;
  }
  
  public async cancelEditingToggle({ component }: IEventParam<Button>) {
    const grid = component.parent as GridEditable;
    await grid.cancelEditedRows();
    this.onInlineEditToggle({ component: grid });
  }
  
  public saveOnDB({ component }: IEventParam<GridEditable>) {
    const gridEditable = component.getEditedRows();
    Http.post('/showOnDashboard', gridEditable);
  }
  
  public async saveEditingToggle({ component }: IEventParam<Button>) {
    const grid = component.parent as GridEditable;
    this.saveOnDB({ component: grid });
    await grid.saveEditedRows();
    this.onInlineEditToggle({ component: grid });
  }
  
  public unitFilter() {
    const unitName = Metadata.getInstance<Select>('unitName');
    const grid = Metadata.getInstance<GridEditable>('servicesGrid');
    const idUnit = unitName.value;
    grid.datasource.filter = idUnit;
    const sendObject = {
      filter: [{
        name: 'CDFILIAL',
        operator: '=',
        value: idUnit,
      }],
    };
    
    Http.post('/unitServices', sendObject).then((response) => {
      const data = response.data.dataset.unitServices;
      grid.datasource.data = data;
      grid.datasource.setFilter([]);
      grid.datasource.updateData(data);
    });
  }
  
  // public getAfTrackingValues() {
  //   const sendObject = {};
  //   const afValues = Http.get('/aFTracking', sendObject);
  //   const data = afValues.dataset.data[0];
  //   console.log(afValues);
  //   this.criticalValue = data.VRLIMMETA;
  // }
  
  public buttonStateAfTracking = true;
  
  public activateButtonAfTracking() {
    this.buttonStateAfTracking = false;
  }
  
  public buttonStateUnitManager = true;
  
  public activateButtonUnitManager() {
    this.buttonStateUnitManager = false;
  }
  
  // public AfTrackingMainForm() {
  //   const form = Metadata.getInstance<Form>('AfTrackingMainForm');
  //   form.validate();
  //   const value = 3;
  //   form.value = { result: value };
  //   form.submit();
  // }
  
  // public teste(values recuperados ) {
  //   criar funcao para formastar o array
  //   return send object
  //   [
  //     29 => VRLIMETA
  //           VRLIMMINIMO
  //     32 => VRLIMETA
  //           VRLIMMINIMO
  //     ]
  // }
  
  public saveAfTracking() {
    const AfCriticalValue = Metadata.getInstance<Number>('AfCriticalValue').value;
    const AfGoal = Metadata.getInstance<Number>('AfGoal').value;
    const AfAnnualDeliveryGoal = Metadata.getInstance<Number>('AfAnnualDeliveryGoal').value;
    const AfTrackingCollapseCard = Metadata.getInstance<CollapseCard>('AfTrackingCollapseCard').header[0].props;
    // sendobject = this.teste()
    const sendObject = {
      AfTrackingCollapseCard,
      AfCriticalValue,
      AfGoal,
      AfAnnualDeliveryGoal,
    };
  
    this.buttonStateAfTracking = true;
    // this.AfTrackingMainForm();
    Http.post('/saveAfTracking', sendObject);
  }
  
  public saveUnitManager() {
    const sendObject = {
      productGrouping: Metadata.getInstance<Select>('productGrouping').value,
      xmlSwitch: Metadata.getInstance<Switch>('xmlSwitch').value,
    };
    
    this.buttonStateUnitManager = true;
    Http.post('/saveUnitManager', sendObject);
  }
  
  // public saveUnitManager() {
  //   const sendObject = {
  //     unitManagerCollapseCard: Metadata.getInstance<CollapseCard>('unitManagerCollapseCard').header[0].props,
  //     daysOfStashGoal: Metadata.getInstance<Number>('daysOfStashGoal').value,
  //     daysOfStashMinimumValue: Metadata.getInstance<Number>('daysOfStashMinimumValue').value,
  //     daysOfDelayLimit: Metadata.getInstance<Number>('daysOfDelayLimit').value,
  //     daysOfDelayMaximumValue: Metadata.getInstance<Number>('daysOfDelayMaximumValue').value,
  //     valueAdjustmentLimit: Metadata.getInstance<Number>('valueAdjustmentLimit').value,
  //     valueAdjustmentMaximumValue: Metadata.getInstance<Number>('valueAdjustmentMaximumValue').value,
  //     extraRequestsValueLimit: Metadata.getInstance<Number>('extraRequestsValueLimit').value,
  //     extraRequestsValueMaximumValue: Metadata.getInstance<Number>('extraRequestsValueMaximumValue').value,
  //     consumptionDeviationLimit: Metadata.getInstance<Number>('consumptionDeviationLimit').value,
  //     consumptionDeviationMaximumValue: Metadata.getInstance<Number>('consumptionDeviationMaximumValue').value,
  //     daysToApproveMenuLimit: Metadata.getInstance<Number>('daysToApproveMenuLimit').value,
  //     daysToApproveMenuMaximumValue: Metadata.getInstance<Number>('daysToApproveMenuMaximumValue').value,
  //   };
    
  //   Http.post('/saveUnitManager', sendObject);
  // }
  // public async saveEditingToggle({ component }: IEventParam<Button>) {
  //   const card = component.parent as Tag;
  //   this.saveAfTracking({ component: card });
  //   await card.saveEditedRows();
  //   this.onInlineEditToggle({ component: card });
  // }
}
